#!/usr/bin/env node
"use strict";
/**
 * internal-dependencies
 * Calculate package dependencies living in the same monorepo
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const fs = __importStar(require("fs"));
const path = __importStar(require("path"));
const t = __importStar(require("io-ts"));
const A = __importStar(require("fp-ts/Array"));
const E = __importStar(require("fp-ts/Either"));
const O = __importStar(require("fp-ts/Option"));
const R = __importStar(require("fp-ts/Record"));
const Ord_1 = require("fp-ts/Ord");
const F = __importStar(require("fluture"));
const shades_1 = require("shades");
const ts_pattern_1 = require("ts-pattern");
const pipeable_1 = require("fp-ts/pipeable");
const function_1 = require("fp-ts/function");
const lerna_utils_1 = require("@typescript-tools/lerna-utils");
const docstring = `
Usage:
    internal-dependencies [--path] <root> <package>...

Options:
    root        Root of lerna mono-repository
    packages    Packages to print dependencies of (also reads from stdin)
    --path      Print the relative path to each package from root
`;
const CommandLineOptions = lerna_utils_1.withEncode(t.type({
    '<root>': t.string,
    '<package>': t.array(t.string),
    '--path': t.boolean
}), a => ({
    root: a['<root>'],
    packages: a['<package>'],
    mode: a['--path'] ? 'path' : 'name'
}));
const unary = (f) => (a) => f(a);
function main() {
    pipeable_1.pipe(lerna_utils_1.decodeCommandLineArguments(CommandLineOptions, docstring, {
        input: [
            ...process.argv.slice(2),
            // file descriptor '0' is stdin
            ...!process.stdin.isTTY ? fs.readFileSync(0, 'utf-8').trim().split('\n') : []
        ]
    }), E.map(options => lerna_utils_1.dependencyGraph(options.root)
        .pipe(F.map(
    // TODO: why is type inferencing breaking down?
    // I think this is this a bug in fluture?
    (graph) => pipeable_1.pipe(options.packages.map(pkg => O.getOrElse(function_1.constant([]))(R.lookup(pkg)(graph))), A.flatten)))
        .pipe(F.map((dependencies) => ts_pattern_1.match(options.mode)
        .with('path', () => dependencies
        .map(shades_1.get('location'))
        .map(location => path.relative(options.root, location)))
        .otherwise(() => dependencies.map(shades_1.get('name')))))
        .pipe(F.map(A.uniq(Ord_1.ordString)))
        .pipe(F.map((dependencies) => dependencies.forEach(unary(console.log))))), 
    // DISCUSS: folding the either into a future
    E.fold(
    // TODO: use validateErrors to print a human-readable error message
    error => {
        console.error(error);
        process.exit(1);
    }, 
    // TODO: set non-zero exit code on failure
    F.fork(console.error)(function_1.constVoid)));
}
main();
// Local Variables:
// mode: typescript
// End:
//# sourceMappingURL=index.js.map